//+------------------------------------------------------------------+
//|                                           Daily PIVOT LEVELS.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
//#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Red
#property indicator_color2 Gray
#property indicator_color3 Gray
#property indicator_color4 Gray
#property indicator_color5 Gray
#property indicator_color6 Gray
#property indicator_color7 Gray

extern bool showtitle = true;
extern int position = 1;
extern int labelsize = 1;
extern int fontsize=8;
extern int myPeriod = PERIOD_D1;
//---- input parameters

//---- buffers
double PBuffer[];
double S1Buffer[];
double R1Buffer[];
double S2Buffer[];
double R2Buffer[];
double S3Buffer[];
double R3Buffer[];


double P,S1,R1,S2,R2,S3,R3;
double LastHigh,LastLow,x;
double open,close,opentoday;
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here

   ObjectDelete("Pivot");
   ObjectDelete("Sup1");
   ObjectDelete("Res1");
   ObjectDelete("Sup2");
   ObjectDelete("Res2");
   ObjectDelete("Sup3");
   ObjectDelete("Res3");   
   
   ObjectDelete("LPivot");
   ObjectDelete("LR1");
   ObjectDelete("LR2");
   ObjectDelete("LR3");
   ObjectDelete("LS1");
   ObjectDelete("LS2");
   ObjectDelete("LS3");
   
   ObjectDelete("txtPivot");
   ObjectDelete("txtR1");
   ObjectDelete("txtR2");
   ObjectDelete("txtR3");
   ObjectDelete("txtS1");
   ObjectDelete("txtS2");
   ObjectDelete("txtS3");
   
   ObjectDelete("standardtext");
   ObjectDelete("standardbg"); 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;


//---- indicator line
   SetIndexStyle(0,DRAW_LINE,0,1,Red);
   SetIndexStyle(1,DRAW_LINE,0,1,Gray);
   SetIndexStyle(2,DRAW_LINE,0,1,Gray);
   SetIndexStyle(3,DRAW_LINE,0,1,Gray);
   SetIndexStyle(4,DRAW_LINE,0,1,Gray);
   SetIndexStyle(5,DRAW_LINE,0,1,Gray);
   SetIndexStyle(6,DRAW_LINE,0,1,Gray);
   SetIndexBuffer(0,PBuffer);
   SetIndexBuffer(1,S1Buffer);
   SetIndexBuffer(2,R1Buffer);
   SetIndexBuffer(3,S2Buffer);
   SetIndexBuffer(4,R2Buffer);
   SetIndexBuffer(5,S3Buffer);
   SetIndexBuffer(6,R3Buffer);


//---- name for DataWindow and indicator subwindow label
   short_name="STANDARD PIVOTS";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);

//----
   SetIndexDrawBegin(0,1);
//----
 

//----
   Comment("");
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()

  {
   int    counted_bars=IndicatorCounted();

   int limit, i;
//---- indicator calculation

   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
//   if(counted_bars>0) counted_bars--;
   limit=(Bars-counted_bars)-1;

for (i=limit; i>=0;i--) {
if (TimeDayOfWeek(Time[i+1])!=0){ // Monday Fix

if (High[i+1]>LastHigh) LastHigh=High[i+1];
if (Low[i+1]<LastLow) LastLow=Low[i+1];

if (TimeDay(Time[i])!= TimeDay(Time[i+1]))
   {
   P=(LastHigh+LastLow+Close[i+1])/3;
   R1 = (2*P)-LastLow;
   S1 = (2*P)-LastHigh;
   R2 = P+(LastHigh - LastLow);
   S2 = P-(LastHigh - LastLow);
   R3 = (2*P)+(LastHigh-(2*LastLow));
   S3 = (2*P)-((2* LastHigh)-LastLow); 
   LastLow=Open[i]; LastHigh=Open[i];

   
   ObjectMove("Pivot", 0, Time[i],P);
   ObjectMove("Sup1", 0, Time[i],S1);
   ObjectMove("Res1", 0, Time[i],R1);
   ObjectMove("Sup2", 0, Time[i],S2);
   ObjectMove("Res2", 0, Time[i],R2);
   ObjectMove("Sup3", 0, Time[i],S3);
   ObjectMove("Res3", 0, Time[i],R3);
   
   SetPrice("LPivot", Time[i], P, Red);
   SetPrice("LS1", Time[i], S1, Gray);
   SetPrice("LS2", Time[i], S2, Gray);
   SetPrice("LS3", Time[i], S3, Gray);
   SetPrice("LR1", Time[i], R1, Gray);
   SetPrice("LR2", Time[i], R2, Gray);
   SetPrice("LR3", Time[i], R3, Gray);
   
   SetText("txtPivot","                                          PIVOT", Time[i], P, White);
   SetText("txtS1","                                     S1", Time[i], S1, White);
   SetText("txtS2","                                     S2", Time[i], S2, White);
   SetText("txtS3","                                     S3", Time[i], S3, White);
   SetText("txtR1","                                     R1", Time[i], R1, White);
   SetText("txtR2","                                     R2", Time[i], R2, White);
   SetText("txtR3","                                     R3", Time[i], R3, White);
  
       
   }
}   
    PBuffer[i]=P;
    S1Buffer[i]=S1;
    R1Buffer[i]=R1;
    S2Buffer[i]=S2;
    R2Buffer[i]=R2;
    S3Buffer[i]=S3;
    R3Buffer[i]=R3;

}

//=SHOW TITLE=
         if (showtitle) 
         {
         ObjectCreate("standardtext", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("standardtext","STANDARD PIVOTS", 18, "Arial Bold", White);
        ObjectSet("standardtext", OBJPROP_CORNER, position);
        ObjectSet("standardtext", OBJPROP_XDISTANCE, 25);
        ObjectSet("standardtext", OBJPROP_YDISTANCE, 8);
       
        
        ObjectCreate("standardbg", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("standardbg", "___________", 28, "Arial", DimGray);
        ObjectSet("standardbg", OBJPROP_CORNER, position);
        ObjectSet("standardbg", OBJPROP_XDISTANCE, 25);
        ObjectSet("standardbg", OBJPROP_YDISTANCE, 1);
        }
       //=END SHOW TITLE=
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetPrice(string name, datetime Tm, double Prc, color clr)
  {
   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_ARROW, 0, Tm, Prc);
       ObjectSet(name, OBJPROP_COLOR, clr);
       ObjectSet(name, OBJPROP_WIDTH, 2);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     }
   else
     {
       ObjectSet(name, OBJPROP_TIME1, Tm);
       ObjectSet(name, OBJPROP_PRICE1, Prc);
       ObjectSet(name, OBJPROP_COLOR, clr);
       ObjectSet(name, OBJPROP_WIDTH, 2);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     } 
  }
  //+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetText(string name, string txt, datetime Tm, double Prc, color clr)
  {
   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_TEXT, 0, Tm, Prc);
       ObjectSetText(name, txt, 8, "Verdana", clr);
       ObjectSet(name, OBJPROP_CORNER, 2);
     }
   else
     {
       ObjectSet(name, OBJPROP_TIME1, Tm);
       ObjectSet(name, OBJPROP_PRICE1, Prc);
       ObjectSetText(name, txt, 8, "Verdana", clr);
       ObjectSet(name, OBJPROP_CORNER, 2);
     } 
  }
//+------------------------------------------------------------------+